Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Eclipse Platform Release 3.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.eclipse.swt.widgets
Class CoolBar

    java.lang.Object
      org.eclipse.swt.widgets.Widget
          org.eclipse.swt.widgets.Control
              org.eclipse.swt.widgets.Scrollable
                  org.eclipse.swt.widgets.Composite
                      org.eclipse.swt.widgets.CoolBar

All Implemented Interfaces:
  Drawable

public class CoolBar
extends Composite

Instances of this class provide an area for dynamically positioning the items they contain.

The item children that may be added to instances of this class must be of type `CoolItem`.

Note that although this class is a subclass of `Composite`, it does not make sense to add `Control` children to it, or set a layout on it.

Styles:
  FLAT
Events:
  (none)

IMPORTANT: This class is not intended to be subclassed.

Field Summary

Fields inherited from class org.eclipse.swt.widgets.Control
`handle`

Constructor Summary
`CoolBar(Composite parent, int style)` Constructs a new instance of this class given its parent and a style value describing its behavior and appearance.

Method Summary
`protected void` | `checkSubclass()` Checks that this class can be subclassed.
`Point` | `computeSize(int wHint, int hHint, boolean changed)` Returns the preferred size of the receiver.
`CoolItem` | `getItem(int index)` Returns the item that is currently displayed at the given, zero-relative index.
`int` | `getItemCount()` Returns the number of items contained in the receiver.
`int[]` | `getItemOrder()` Returns an array of zero-relative ints that map the creation order of the receiver's items to the order in which they are currently being displayed.
`CoolItem[]` | `getItems()` Returns an array of `CoolItem`s in the order in which they are currently being displayed.
`Point[]` | `getItemSizes()` Returns an array of points whose x and y coordinates describe the widths and heights (respectively) of the items in the receiver in the order in which they are currently being displayed.
`boolean` | `getLocked()` Returns whether or not the receiver is 'locked'.
`int[]` | `getWrapIndices()` Returns an array of ints that describe the zero-relative indices of any item(s) in the receiver that will begin on a new row.
`int` | `indexOf(CoolItem item)` Searches the receiver's items in the order they are currently being displayed, starting at the first item (index 0), until an item is found that is equal to the argument, and returns the index of that item.
`void` | `setItemLayout(int[] itemOrder, int[] wrapIndices, Point[] sizes)` Sets the receiver's item order, wrap indices, and item sizes all at once.
`void` | `setLocked(boolean locked)` Sets whether or not the receiver is 'locked'.
`void` | `setWrapIndices(int[] indices)` Sets the indices of all item(s) in the receiver that will begin on a new row.

Methods inherited from class org.eclipse.swt.widgets.Composite
`getChildren, getLayout, getTabList, layout, layout, setFocus, setLayout, setTabList`

Methods inherited from class org.eclipse.swt.widgets.Scrollable
`computeTrim, getClientArea, getHorizontalBar, getVerticalBar`

Methods inherited from class org.eclipse.swt.widgets.Control
`addControlListener, addFocusListener, addHelpListener, addKeyListener, addMouseListener, addMouseMoveListener, addMouseTrackListener, addPaintListener, addTraverseListener, computeSize, forceFocus, getAccessible, getBackground, getBorderWidth, getBounds, getEnabled, getFont, getForeground, getLayoutData, getLocation, getMenu, getMonitor, getParent, getShell, getSize, getToolTipText, getVisible, internal_dispose_GC, internal_new_GC, isEnabled, isFocusControl, isReparentable, isVisible, moveAbove, moveBelow, pack, pack, redraw, redraw, removeControlListener, removeFocusListener, removeHelpListener, removeKeyListener, removeMouseListener, removeMouseMoveListener, removeMouseTrackListener, removePaintListener, removeTraverseListener, setBackground, setBounds, setBounds, setCapture, setCursor, setEnabled, setFont, setForeground, setLayoutData, setLocation, setLocation, setMenu, setParent, setRedraw, setSize, setSize, setToolTipText, setVisible, toControl, toControl, toDisplay, toDisplay, traverse, update`

Methods inherited from class org.eclipse.swt.widgets.Widget
`addDisposeListener, addListener, checkWidget, dispose, getData, getData, getDisplay, getStyle, isDisposed, isListening, notifyListeners, removeDisposeListener, removeListener, removeListener, setData, setData, toString`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### CoolBar

    public CoolBar(Composite parent,
                   int style)

  Constructs a new instance of this class given its parent and a style value describing its behavior and appearance.

  The style value is either one of the style constants defined in class `SWT` which is applicable to instances of this class, or must be built by bitwise OR'ing together (that is, using the `int` "|" operator) two or more of those `SWT` style constants. The class description lists the style constants that are applicable to the class. Style bits are also inherited from superclasses.

Parameters:
  `parent` - a composite control which will be the parent of the new instance (cannot be null)
  `style` - the style of control to construct
Throws:
  `IllegalArgumentException` -
  - ERROR_NULL_ARGUMENT - if the parent is null
  `SWTException` -
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the parent
  - ERROR_INVALID_SUBCLASS - if this class is not an allowed subclass
See Also:
  `SWT`, `Widget.checkSubclass()`, `Widget.getStyle()`

Method Detail

### checkSubclass

    protected void checkSubclass()

  Description copied from class: `Widget`
  Checks that this class can be subclassed.

  The SWT class library is intended to be subclassed only at specific, controlled points (most notably, `Composite` and `Canvas` when implementing new widgets). This method enforces this rule unless it is overridden.

  IMPORTANT: By providing an implementation of this method that allows a subclass of a class which does not normally allow subclassing to be created, the implementer agrees to be fully responsible for the fact that any such subclass will likely fail between SWT releases and will be strongly platform specific. No support is provided for user-written classes which are implemented in this fashion.

  The ability to subclass outside of the allowed SWT classes is intended purely to enable those not on the SWT development team to implement patches in order to get around specific limitations in advance of when those limitations can be addressed by the team. Subclassing should not be attempted without an intimate and detailed understanding of the hierarchy.

  Overrides:
    `checkSubclass` in class `Composite`

### computeSize

    public Point computeSize(int wHint,
                             int hHint,
                             boolean changed)

  Description copied from class: `Control`
  Returns the preferred size of the receiver.

  The preferred size of a control is the size that it would best be displayed at. The width hint and height hint arguments allow the caller to ask a control questions such as "Given a particular width, how high does the control need to be to show all of the contents?" To indicate that the caller does not wish to constrain a particular dimension, the constant `SWT.DEFAULT` is passed for the hint.

  If the changed flag is `true`, it indicates that the receiver's contents have changed, therefore any caches that a layout manager containing the control may have been keeping need to be flushed. When the control is resized, the changed flag will be `false`, so layout manager caches can be retained.

  Overrides:
    `computeSize` in class `Composite`

### getItem

    public CoolItem getItem(int index)

  Returns the item that is currently displayed at the given, zero-relative index. Throws an exception if the index is out of range.

  Parameters:
    `index` - the visual index of the item to return
  Returns:
    the item at the given visual index
  Throws:
    `IllegalArgumentException` -
    - ERROR_INVALID_RANGE - if the index is not between 0 and the number of elements in the list minus 1 (inclusive)
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
    `SWTError` -
    - ERROR_CANNOT_GET_ITEM - if the operation fails because of an operating system failure

### getItemCount

    public int getItemCount()

  Returns the number of items contained in the receiver.

  Returns:
    the number of items
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
    `SWTError` -
    - ERROR_CANNOT_GET_COUNT - if the operation fails because of an operating system failure

### getItemOrder

    public int[] getItemOrder()

  Returns an array of zero-relative ints that map the creation order of the receiver's items to the order in which they are currently being displayed.

  Specifically, the indices of the returned array represent the current visual order of the items, and the contents of the array represent the creation order of the items.

  Note: This is not the actual structure used by the receiver to maintain its list of items, so modifying the array will not affect the receiver.

  Returns:
    the current visual order of the receiver's items
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
    `SWTError` -
    - ERROR_CANNOT_GET_ITEM - if the operation fails because of an operating system failure

### getItems

    public CoolItem[] getItems()

  Returns an array of `CoolItem`s in the order in which they are currently being displayed.

  Note: This is not the actual structure used by the receiver to maintain its list of items, so modifying the array will not affect the receiver.

  Returns:
    the receiver's items in their current visual order
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
    `SWTError` -
    - ERROR_CANNOT_GET_ITEM - if the operation fails because of an operating system failure

### getItemSizes

    public Point[] getItemSizes()

  Returns an array of points whose x and y coordinates describe the widths and heights (respectively) of the items in the receiver in the order in which they are currently being displayed.

  Returns:
    the receiver's item sizes in their current visual order
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### getLocked

    public boolean getLocked()

  Returns whether or not the receiver is 'locked'. When a coolbar is locked, its items cannot be repositioned.

  Returns:
    true if the coolbar is locked, false otherwise
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
  Since:
    2.0

### getWrapIndices

    public int[] getWrapIndices()

  Returns an array of ints that describe the zero-relative indices of any item(s) in the receiver that will begin on a new row. The 0th visible item always begins the first row, therefore it does not count as a wrap index.

  Returns:
    an array containing the receiver's wrap indices, or an empty array if all items are in one row
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### indexOf

    public int indexOf(CoolItem item)

  Searches the receiver's items in the order they are currently being displayed, starting at the first item (index 0), until an item is found that is equal to the argument, and returns the index of that item. If no item is found, returns -1.

  Parameters:
    `item` - the search item
  Returns:
    the visual order index of the search item, or -1 if the item is not found
  Throws:
    `IllegalArgumentException` -
    - ERROR_NULL_ARGUMENT - if the item is null
    - ERROR_INVALID_ARGUMENT - if the item is disposed
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### setItemLayout

    public void setItemLayout(int[] itemOrder,
                              int[] wrapIndices,
                              Point[] sizes)

  Sets the receiver's item order, wrap indices, and item sizes all at once. This method is typically used to restore the displayed state of the receiver to a previously stored state.

  The item order is the order in which the items in the receiver should be displayed, given in terms of the zero-relative ordering of when the items were added.

  The wrap indices are the indices of all item(s) in the receiver that will begin on a new row. The indices are given in the order specified by the item order. The 0th item always begins the first row, therefore it does not count as a wrap index. If wrap indices is null or empty, the items will be placed on one line.

  The sizes are specified in an array of points whose x and y coordinates describe the new widths and heights (respectively) of the receiver's items in the order specified by the item order.

  Parameters:
    `itemOrder` - an array of indices that describe the new order to display the items in
    `wrapIndices` - an array of wrap indices, or null
    `sizes` - an array containing the new sizes for each of the receiver's items in visual order
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
    `IllegalArgumentException` -
    - ERROR_NULL_ARGUMENT - if item order or sizes is null
    - ERROR_INVALID_ARGUMENT - if item order or sizes is not the same length as the number of items
    `SWTError` -
    - ERROR_CANNOT_GET_ITEM - if the operation fails because of an operating system failure

### setLocked

    public void setLocked(boolean locked)

  Sets whether or not the receiver is 'locked'. When a coolbar is locked, its items cannot be repositioned.

  Parameters:
    `locked` - lock the coolbar if true, otherwise unlock the coolbar
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
  Since:
    2.0

### setWrapIndices

    public void setWrapIndices(int[] indices)

  Sets the indices of all item(s) in the receiver that will begin on a new row. The indices are given in the order in which they are currently being displayed. The 0th item always begins the first row, therefore it does not count as a wrap index. If indices is null or empty, the items will be placed on one line.

  Parameters:
    `indices` - an array of wrap indices, or null
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Eclipse Platform Release 3.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Guidelines for using Eclipse APIs.

Copyright (c) IBM Corp. and others 2000, 2004. All rights reserved.